#include <xc.h>
#include "7segment.h"

const unsigned char sevenSegDigitArray[] = {0b11111100,0b01100000,0b11011010,0b11110010,0b01100110,0b10110110,0b10111110,0b11100000,0b11111110,0b11110110};

static unsigned char sevenSegUnitValue;
static unsigned char sevenSegDecadeValue;

void sevenSegSetNumber(unsigned char valueToDisplay){
    if(valueToDisplay>99){  //Display "HI"
        #ifdef sevenSegCommonAnode
        sevenSegDecadeValue=0b10010001;
        sevenSegUnitValue=0b11110011;
        #else
        sevenSegDecadeValue=0b01101110;
        sevenSegUnitValue=0b00001100;
        #endif
    }
    else{
        #ifdef sevenSegCommonAnode
        sevenSegDecadeValue=~sevenSegDigitArray[valueToDisplay/10];
        sevenSegUnitValue=~sevenSegDigitArray[valueToDisplay%10];
        #else
        sevenSegDecadeValue=sevenSegDigitArray[valueToDisplay/10];
        sevenSegUnitValue=sevenSegDigitArray[valueToDisplay%10];
        #endif
    }
}

void sevenSegSetUnitDigit(unsigned char digitValue){
    #ifdef sevenSegCommonAnode
    sevenSegUnitValue = ~sevenSegDigitArray[digitValue>9?digitValue%10:digitValue];
    #else
    sevenSegUnitValue = sevenSegDigitArray[digitValue];
    #endif
}

void sevenSegSetDecadeDigit(unsigned char digitValue){
    #ifdef sevenSegCommonAnode
    sevenSegDecadeValue = ~sevenSegDigitArray[digitValue>9?digitValue%10:digitValue];
    #else
    sevenSegDecadeValue = sevenSegDigitArray[digitValue];
    #endif
}

void sevenSegSetRawValue(unsigned char decade, unsigned char unit){
    #ifdef sevenSegCommonAnode
    sevenSegDecadeValue=~decade;
    sevenSegUnitValue=~unit;
    #else
    sevenSegDecadeValue=decade;
    sevenSegUnitValue=unit;
    #endif
}

void sevenSegRefreshDisplay(void){
    static char unitDigitBeingDisplayed = 0;
    if(unitDigitBeingDisplayed>0){
        sevenSegUnitCathodePin=sevenSegDigitOff;
        sevenSegOutputPort=sevenSegDecadeValue;
        sevenSegDecadeCathodePin=sevenSegDigitOn;
        unitDigitBeingDisplayed=0;
    }
    else{
        sevenSegDecadeCathodePin=sevenSegDigitOff;
        sevenSegOutputPort=sevenSegUnitValue;
        sevenSegUnitCathodePin=sevenSegDigitOn;
        unitDigitBeingDisplayed=1;
    }
}
