/* 
 * File:   7segment.h
 * Author: Pila
 *
 * Created on 2 janvier 2014, 17:04
 */

#ifndef SEGMENT_H
#define	SEGMENT_H
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!                                       !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!               SETTINGS                !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!     edit this part to match your      !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!        hardware configuration         !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!                                       !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


#define sevenSegUnitCathodePin      PORTAbits.RA0
#define sevenSegDecadeCathodePin    PORTAbits.RA1
#define sevenSegOutputPort          PORTB

//#define sevenSegCommonAnode       //uncomment this line if using a common anode display

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!                                       !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!                HEADERS                !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!          do not edit below            !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!                                       !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


//display a number between 0 and 99 (included). Greater numbers displayed as "HI"
void sevenSegSetNumber(unsigned char valueToDisplay);

//allow to set directly the state of each segment. The common anode / common cathode
//stuff is handled, so any bit set to 1 will always turn the corresponding segment on.
void sevenSegSetRawValue(unsigned char decade, unsigned char unit);

//allow to change only the unit digit value. The displayed value is digitValue%10
void sevenSegSetUnitDigit(unsigned char digitValue);

//allow to change only the decade digit value. The displayed value is digitValue%10
void sevenSegSetDecadeDigit(unsigned char digitValue);

//this function handle the display. Each call handles one digit. You must call it
//more than 60 times per second to avoid visible flicker of the display. In most
//programs, this function is called by an interruption routine. A >=100Hz call rate gives
//a very nice, flicker-free display.
void sevenSegRefreshDisplay(void);

//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!                                       !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!                STUFF                  !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!         do not edit neither           !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!                                       !!!!!!!!!!!!!!!!!!!!
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef sevenSegCommonAnode
    #define sevenSegDigitOn 0
    #define sevenSegDigitOff 1
#else
    #define sevenSegDigitOn 1
    #define sevenSegDigitOff 0
#endif
#endif	/* SEGMENT_H */

